function(cppm_create_symlink)
    cmake_parse_arguments(ARG "" "" "" ${ARGN})
    list(GET ARG_UNPARSED_ARGUMENTS 0 path)
    set(cppm_manifest "${CPPM_TARGET_BINARY_DIR}/install_manifest.txt")
    if(NOT EXISTS "${cppm_manifest}")
        cppm_warning_print(WARNING "Cannot find install manifest: ${cppm_manifest}")
        return()
    endif()

    file(GLOB bins "${path}/bin/*")
    foreach(bin IN LISTS bins)
        get_filename_component(bin_name ${bin} NAME)
        message(STATUS "Cppm-slink: ${CPPM_ROOT}/bin/${bin_name} -> ${bin}")
        execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink "${bin}" "${CPPM_ROOT}/bin/${bin_name}")
        file(APPEND ${cppm_manifest} "\n${CPPM_ROOT}/bin/${bin_name}")
    endforeach()
endfunction()
